// Copyright 2012 Daniel Craig Giffen
// http://www.humanclock.com
//
var cfg_checkForUpdateUrl = cfg_apiUrl + '/checkversion.php';
var iframeUrl = cfg_apiUrl +'/iframe.php';
var defaultPrefs = {clockType:'mdou',
                   filter_h: ''
                   };
var currentPrefs = {};
var userPrefsKey = 'userPrefs';                   
var lastUpdateEpoch = 0;
var connectionSuccessFlag = 0;

var frameDefs = {'mdou':{
                            'windowW':'262',
                            'windowH':'246',
                            'desc':'Digital Medium',
                            'html':'<iframe id="srcFrame" src="" style="width:265px;height:250px;border:0px;margin:0px;overflow:hidden" frameborder="0" scrolling="no"></iframe>'
                            },
                 'smou':{
                            'windowW':'159',
                            'windowH':'159',
                            'desc':'Digital Small',
                            'html':'<iframe id="srcFrame" src="" style="width:160px;height:190px;border:0px;margin:0px;overflow:hidden" frameborder="0" scrolling="no"></iframe>'
                            },
                'amd':{
                            'windowW':'264',
                            'windowH':'284',
                            'desc':'Analog Medium',
                            'html':'<iframe id="srcFrame" src="" style="width:265px;height:285px;border:0px;margin:0px;overflow:hidden" frameborder="0" scrolling="no"></iframe>'
                            },
                'asm':{
                            'windowW':'160',
                            'windowH':'184',
                            'desc':'Analog Small',
                            'html':'<iframe id="srcFrame" src="" style="width:160px;height:185px;border:0px;margin:0px;overflow:hidden" frameborder="0" scrolling="no"></iframe>'
                            }
    
                };

function load(){
    
    port_initialSetup();
    
    //////////////// SETUP FRONT PANEL ////////////////////
    // Clicks go to website
    $('#iframeLink').click(function() {
        port_openURL(cfg_wwwUrl);
    });

    // Mouseovers show the control panel buttons
    //  Use opacity because the new version button might or might
    //  not be shown
    $('#front').mouseover(function() {
         $('.controlBtn').css('opacity','1');
         port_newVersionCheck();
    });
    $('#front').mouseout(function() {
         $('.controlBtn').css('opacity','0')
    });
        
    // Set the click url for the "new version available" button
    $('#btnNewVersion').click(function() {
        port_openURL(cfg_wwwUrl + '/widget.php');
    });

    // Set the click handler for the settings button
    $('#btnSettings').click(function() {
            $('#front').fadeOut();
            $('#back').fadeIn();
    });

    $('#btnRetry').click(function() {
        updateClockIframe();    
    });

        
    //////////////// SETUP BACK PANEL ////////////////////


    // Set the clock type and time format pulldown containers
    var content = '<select id="clockType" class="option">';
    for (i in frameDefs) {
        content += '<option value="' + i + '">' +frameDefs[i]['desc'] + '</option>';            
    }
    content += '</select>';

    content += '<select id="filter_h" class="option">';
    content += '<option value="">-any-</option>';
    content += '<option value="12">12 hr (3:45pm)</option>';
    content += '<option value="24">24 hr (15:45)</option>';
    content += '</select>';
    $('#optionsContainer').html(content);

    // Set the change handlers
    $('.option').click(function() {

        // Update the current preference value
        // filters are stored differently
        id = $(this).attr('id');
        currentPrefs[id] = $(this).val();
        port_saveVariable(id,$(this).val());
    });    

    // Set the click handler for the done button
    $('#btnDone').click(function() {
            updateClockIframe();
            $('#front').show();
            $('#back').fadeOut(3000);

    })

    // Set the version number
    $('#versionContainer').html(parseFloat(currentVersion).toFixed(1));    

    // Setup the current preferences values using defaults or the user's stored preferences
    var test;
    for (i in defaultPrefs) {
        test = port_loadVariable(i);
        if (typeof test != 'undefined') {
            currentPrefs[i] = test;
        } else {
          currentPrefs[i] = defaultPrefs[i];
        }
        $('#'+i).val(currentPrefs[i]);
    }

    // Load the iframe and fade in
    updateClockIframe();  
}



/////// Load an iframe
function updateClockIframe() {

    currentCode = currentPrefs['clockType'];

    // Build the iframe base url
    url = iframeUrl + '?' + buildArgs(currentCode);

    // Swap the url into the html content and apply to the
    // front panel
    htmlContent = frameDefs[currentCode]['html'];
    htmlContent = htmlContent.replace(/src=""/,'src="'+url+'"');
    $('#iframeContainer').html(htmlContent);

    // Size the main body (this is needed by win7 sidebar)
    document.body.style.width = parseInt(frameDefs[currentCode]['windowW']);
    document.body.style.height = parseInt(frameDefs[currentCode]['windowH']);

    // Resize and move the front settings button
    window.resizeTo(frameDefs[currentCode]['windowW'], frameDefs[currentCode]['windowH']);
    $('#btnSettings').css('right','5px').css('bottom','5px');
    $('#btnNewVersion').css('left','5px').css('top','5px');

    // Resize the back panel and other page elements
    $('#back').css('width',frameDefs[currentCode]['windowW']+'px').css('height',frameDefs[currentCode]['windowH']+'px');
    $('#base').css('width',frameDefs[currentCode]['windowW']+'px').css('height',frameDefs[currentCode]['windowH']+'px');
    $('#iframeLink').css('width',frameDefs[currentCode]['windowW']+'px').css('height',frameDefs[currentCode]['windowH']+'px');
    $('#loadErrorNotice').css('width',(frameDefs[currentCode]['windowW'] - 5)+'px').css('height',(frameDefs[currentCode]['windowH']-5)+'px');
}


// Build the url request arguments
function buildArgs(mode) {
    var args = 'sclf=1&amp;mode='+mode;
    var tmp = '';
    for (i in currentPrefs) {
        if (i.substr(0,6) == 'filter') {
            var key = i.replace('filter_','');
            tmp += (tmp != ''?"\t":'') + key + '=' + currentPrefs[i];
        }
    }
    if (tmp != '') { args += '&amp;f=' + escape(tmp); }
    return args;
}
