// OSX Dashboard - Windows 7 Porting functions

// Initial setup actions
function port_initialSetup() {

    // Remove click layer since it is not needed for win7
    if (typeof System != 'undefined') {
        $('#iframeLink').hide();
    }
}


// Open a url in a browser
function port_openURL(url) {
    if (window.widget) {
        widget.openURL(url);
   }
   
    if (typeof System != 'undefined') {
        window.open(url);
    }
}

// Save a stored variable
function port_saveVariable(key,value){
    if (window.widget) {
        widget.setPreferenceForKey(value,key);
    }
    
    if (typeof System != 'undefined') {
        System.Gadget.Settings.writeString(key,value);
    }
}

// Load a stored variable
function port_loadVariable(key) {
    if (typeof System != 'undefined') {
        System.Gadget.Settings.readString(key);
    }   
    if (window.widget) {
        return widget.preferenceForKey(key);
    }
}

// Check for update, enable/disable the button from the control panel if needed
function port_newVersionCheck() {
    
    // Skip if it has not been a day since we last checked
    nowEpoch = (new Date).getTime();
    if ((lastUpdateEpoch + 86400000 > nowEpoch)
        && connectionSuccessFlag != 0){
        return;
    }
    lastUpdateEpoch = nowEpoch;
    
    // Check for update: OSX
    if (window.widget) {
        $.get(cfg_checkForUpdateUrl + '?t=osxdb', function(data){
            receivedVersion = parseFloat(data);
            if (receivedVersion > parseFloat(currentVersion)) {
                $('#btnNewVersion').show();
            } else {
                $('#btnNewVersion').hide();
            }
        });
    }
    
    // Check for update: Win7
    // Also verify we have a connection
    //  This needs to be done with images
    if (typeof System != 'undefined'
        || connectionSuccessFlag == 0) {

        // Check for heartbeat and new version
        var test = new Image();
        test.onerror = function () {
            $('#loadErrorNotice').show(); 
            connectionSuccessFlag = 0;
        }
        test.onload = function() {
            connectionSuccessFlag = 1;
            $('#loadErrorNotice').hide(); 

            // Image is bigger than 1x1, show new version message and set click url
            if (test.width > 1) {
                 $('#btnNewVersion').addClass('controlBtn')

            } else {
                 $('#btnNewVersion').removeClass('controlBtn');
            }
           }
           test.src = cfg_checkForUpdateUrl + '?cb='+(Math.floor(Math.random()*1000000000000000))+'&t=win7&v='+currentVersion
    }
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove(){
    // Stop any timers to prevent CPU usage
    
    // Remove any preferences as needed
    for (i in defaultPrefs) {
        port_saveVariable(i,null);
    }
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide(){
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show(){

    // Check for new version
    port_newVersionCheck();
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
}


